﻿Public Class frmMain

    ' Einschalten wenn fertig!
#Region "Nachfrage Beenden"
    'Inherits Form
    'Protected Overrides Sub WndProc(ByRef m As Message)
    '    Const WM_SYSCOMMAND As Integer = &H112
    '    Const SC_CLOSE As Integer = &HF060
    '    If m.Msg = WM_SYSCOMMAND AndAlso m.WParam.ToInt32() = SC_CLOSE Then
    '        Dim result As DialogResult = MessageBox.Show("Möchten Sie die Änderungen speichern?", "Wichtige Frage - Daten Speichern!", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question)
    '        If result = DialogResult.Yes Then
    '            ' Daten speichern
    '            _xmlManager.SaveXMLData(_filePathsConfig.XMLFileName)
    '        ElseIf result = DialogResult.Cancel Then
    '            ' Abbruch des Schließens
    '            Return
    '        End If
    '    End If
    '    MyBase.WndProc(m)
    'End Sub
#End Region

    ' Klassen einbinden
    Public WithEvents _filePathsConfig As New FilePathsConfig
    Public WithEvents _xmlManager As New XmlManager
    Public WithEvents _dateManager As DateManager
    Public WithEvents _calcYeardata As New CalcYeardata
    ' Variable zum Überprüfen, ob die MessageBox angezeigt wird
    ' und in einer Zelle etwas geändert wurde
    Private isMessageBoxShown As Boolean = False
    Private inCellValidating As Boolean = False

    Public Sub New()
        InitializeComponent()
        ' Erstelle Instanz der DateManager-Klasse und übergebe die erforderlichen Argumente
        _filePathsConfig.präfixPath = "Jahr-" & dtpDatum.Value.ToString("yyyy")
        Debug.WriteLine("Form: " & _filePathsConfig.präfixPath)
        CheckAndCreateDirectory()
        _dateManager = New DateManager(_filePathsConfig, _xmlManager, dtpDatum)
        _filePathsConfig.fileSufix = dtpDatum.Value.ToString("MM-yyyy")
        ToollblMonth.Text = dtpDatum.Value.ToString("MMMM-yyyy")
        lblDatum.Text = dtpDatum.Value.ToString("dddd dd.MMMM.yyyy")
        _dateManager.Loadxml()

        'Berechnung klappt nicht
        'Jahresauswertung()
    End Sub

    ' Neuen Jahres-Ordner erstellen wenn nicht vorhanden.
    Private Sub CheckAndCreateDirectory()
        Dim directoryName As String = _filePathsConfig.präfixPath
        Dim directoryPath As String = Path.Combine(_filePathsConfig.filePath, directoryName)
        If Not Directory.Exists(directoryPath) Then
            Directory.CreateDirectory(directoryPath)
            'Debug.WriteLine("Verzeichnis '" & directoryName & "' wurde erstellt.")
        End If
    End Sub

    ' Daten für den aktl. Monat us dem XML laden
    Private Sub Loadxml()
        If File.Exists(_filePathsConfig.XMLFileName) Then
            'Debug.WriteLine("FormLoadXML: " & _filePathsConfig.XMLFileName)
            _xmlManager.LoadXMLData(_filePathsConfig.XMLFileName)
        Else
            Dim daysInMonth As Integer = DateTime.DaysInMonth(dtpDatum.Value.Year, dtpDatum.Value.Month)
            _xmlManager.CreateNewMonth(_filePathsConfig.XMLFileName, daysInMonth)
            _xmlManager.LoadXMLData(_filePathsConfig.XMLFileName)
        End If
    End Sub
    ' DateTimePicker
    Private Sub dtpDatum_ValueChanged(sender As Object, e As EventArgs) Handles dtpDatum.ValueChanged
        _filePathsConfig.fileSufix = dtpDatum.Value.ToString("MM-yyyy")
        ToollblMonth.Text = dtpDatum.Value.ToString("MMMM-yyyy")
    End Sub

    ' Beim Monatswechsel prüfen ob Änderungen gemacht wurden
    Private Sub UpdateDateAndLoadXml(monthOffset As Integer)
        Dim xmlManager As New XmlManager()
        Dim dgvData As DataGridView = WeatherGridView
        ' Überprüfen, ob die Daten geändert wurden
        If xmlManager.DatenGeändert(dgvData) Then
            Dim result As DialogResult = MessageBox.Show("Möchten Sie die Änderungen speichern?", "Hinweis - Daten Speichern", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
            If result = DialogResult.Yes Then
                dgvData.EndEdit()
                _xmlManager.SaveXMLData(_filePathsConfig.XMLFileName)
            End If
        End If
        dtpDatum.Value = dtpDatum.Value.AddMonths(monthOffset)
        Loadxml()
    End Sub

    Private Sub btnPrevMonth_Click(sender As Object, e As EventArgs) Handles btnPrevMonth.Click
        UpdateDateAndLoadXml(-1)
    End Sub

    Private Sub btnNextMonth_Click(sender As Object, e As EventArgs) Handles btnNextMonth.Click
        UpdateDateAndLoadXml(1)
    End Sub

    ' Button zum Speichern des aktl. Monat
    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        ' Speichern der Änderungen im DataGridView
        WeatherGridView.EndEdit()
        ' Aufrufen der SaveXMLData-Methode, um das XML zu speichern
        _xmlManager.SaveXMLData(_filePathsConfig.XMLFileName)
    End Sub

    ' Evendhandler Daten in das DGV einlesen
    Private Sub XMLReadHandler(sender As Object, e As DataTable) Handles _xmlManager.XMLRead
        WeatherGridView.Refresh()
        _xmlManager.dtWeatherData = e
        WeatherGridView.DataSource = _xmlManager.dtWeatherData.DefaultView
        WeatherGridView.Columns(0).ReadOnly = True
        WeatherGridView.AllowUserToAddRows = False
    End Sub

    ' Eventhandler Daten Speichern
    Private Sub XMLSaveHandler(sender As Object, e As Object) Handles _xmlManager.XMLSave
        MessageBox.Show("Die Monatsdaten wurden erfolgreich gespeichert." & Environment.NewLine & "Datei: " & _filePathsConfig.XMLFileName, "XML-Datei-Erfolg", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    ' Eventhandler Daten Speichern
    Private Sub XMLCreateHandler(sender As Object, e As Object) Handles _xmlManager.XMLCreate
        MessageBox.Show("Die Monatsdatei wurde erfolgreich angelegt." & Environment.NewLine & "Datei: " & _filePathsConfig.XMLFileName, "XML-Datei-Erfolg", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    ' Eventhandler Daten Lesen / Speicher Fehler
    Private Sub XMLErrorHandler(sender As Object, message As String) Handles _xmlManager.XMLError
        MessageBox.Show("Fehler beim Lesen / Speichern der XML-Datei: " & Environment.NewLine & message, "XML-Datei-Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub


#Region "DGV Formatieren / Einstellen"
    Private Sub WeatherGridView_CellFormatting(sender As Object, e As DataGridViewCellFormattingEventArgs) Handles WeatherGridView.CellFormatting
        If e.ColumnIndex >= 3 Then
            If CDbl(e.Value) < 0 Then
                e.CellStyle.ForeColor = Color.Red
            ElseIf CDbl(e.Value) > 0 Then
                e.CellStyle.ForeColor = Color.Black
            End If
        End If
        If e.RowIndex Mod 2 = 1 Then
            e.CellStyle.BackColor = Color.LightGray
        End If
    End Sub

    Private Sub WeatherGridView_EditingControlShowing(sender As Object, e As DataGridViewEditingControlShowingEventArgs) Handles WeatherGridView.EditingControlShowing
        ' Überprüfe, ob das Bearbeitungssteuerelement eine TextBox in der DataGridView ist
        If TypeOf e.Control Is TextBox AndAlso sender Is WeatherGridView Then
            Dim textBox As TextBox = DirectCast(e.Control, TextBox)
            ' Überprüfe, ob die Bearbeitung in den gewünschten Spalten stattfindet
            If WeatherGridView.CurrentCell.ColumnIndex >= 3 Then
                ' Füge das Ereignis TextChanged hinzu
                AddHandler textBox.TextChanged, AddressOf TextBox_TextChanged
            End If
        End If
    End Sub

    Private Sub TextBox_TextChanged(sender As Object, e As EventArgs)
        ' Überprüfe, ob der Sender des Ereignisses eine TextBox ist
        If TypeOf sender Is TextBox Then
            Dim textBox As TextBox = DirectCast(sender, TextBox)
            ' Überprüfe, ob der eingegebene Text einen Punkt enthält
            If textBox.Text.Contains(".") Then
                ' Ersetze den Punkt durch ein Komma
                textBox.Text = textBox.Text.Replace(".", ",")
                ' Setze den Cursor an das Ende des Textes
                textBox.SelectionStart = textBox.TextLength
            End If
        End If
    End Sub
#End Region



#Region "Tabelle drucken"
    Private Sub TabelleDruckenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles TabelleDruckenToolStripMenuItem.Click
        Dim dt As DataTable = Nothing
        Dim ut As String = ""
        ' Ereignishandler für das XMLRead-Ereignis hinzufügen
        AddHandler _xmlManager.XMLRead, Sub(xmlSender As Object, data As DataTable)
                                            dt = data
                                        End Sub
        _xmlManager.LoadXMLData(_filePathsConfig.XMLFileName)
        ' Warten, bis das XMLRead-Ereignis aufgerufen wurde und die Daten geladen wurden
        While dt Is Nothing
            Application.DoEvents()
        End While
        Dim reportTitle As String = "Wetterstatistik für den Monat: " & dtpDatum.Value.ToString("MMMM-yyyy")
        Dim printingHelper As New PrintingHelper(dt, reportTitle, ut)
        ' Direkter Aufruf der Druckfunktion ohne Schleife
        printingHelper.Print()
    End Sub
#End Region



#Region "Jahresauswertungen"
    Private Sub Jahresauswertung()
        'Dim calcYearData As New _calcYeardata()
        AddHandler _calcYeardata.YearDataCalculated, AddressOf UpdateDataGridView
        _calcYeardata.CalculateYearlyAverages(_filePathsConfig.präfixPath)
    End Sub

    Private Sub UpdateDataGridView(ByVal yearData As List(Of Double))
        ' Das DataGridView mit dem Namen "dgvaYear" aktualisieren
        dgvaYear.Columns.Clear()
        dgvaYear.Rows.Clear()
        ' Spalten für die Jahresdaten hinzufügen
        dgvaYear.Columns.Add("Datum", "Datum")
        dgvaYear.Columns.Add("Regen24h", "Regen24h")
        dgvaYear.Columns.Add("SchneeTag", "SchneeTag")
        dgvaYear.Columns.Add("SchneeNacht", "SchneeNacht")
        dgvaYear.Columns.Add("LuftfminTag", "LuftfminTag")
        dgvaYear.Columns.Add("LuftfmaxTag", "LuftfmaxTag")
        dgvaYear.Columns.Add("LuftfminNacht", "LuftfminNacht")
        dgvaYear.Columns.Add("LuftfmaxNacht", "LuftfmaxNacht")
        dgvaYear.Columns.Add("TempTag", "TempTag")
        dgvaYear.Columns.Add("TempNacht", "TempNacht")
        dgvaYear.Columns.Add("WindTag", "WindTag")
        dgvaYear.Columns.Add("WindNacht", "WindNacht")
        ' ÄndertSpaltenüberschriften
        For Each column As DataGridViewColumn In dgvaYear.Columns
            column.DefaultCellStyle.Font = New Font("Arial", 9, FontStyle.Regular) ' Schriftart und Größe anpassen
            column.DefaultCellStyle.ForeColor = Color.Firebrick ' Textfarbe auf Blau setzen
            column.HeaderCell.Style.Font = New Font("Arial", 7.5, FontStyle.Regular) ' Überschriften-Schriftart und Größe anpassen
            column.HeaderCell.Style.ForeColor = Color.Blue ' Überschriften-Textfarbe auf Blau setzen
        Next
        ' Datenzeile hinzufügen
        Dim newRow As DataGridViewRow = New DataGridViewRow()
        newRow.CreateCells(dgvaYear)
        newRow.Cells(0).Value = _filePathsConfig.präfixPath '"Schnitt"
        For i As Integer = 0 To yearData.Count - 1
            If i < dgvaYear.Columns.Count - 1 Then ' Überprüfen Sie die Anzahl der Spalten
                newRow.Cells(i + 1).Value = yearData(i) ' Fügen Sie die Daten in eine neue Zeile ein
            End If
        Next
        dgvaYear.Rows.Add(newRow)
    End Sub
#End Region

End Class